'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _tabs = require('antd/lib/tabs');

var _tabs2 = _interopRequireDefault(_tabs);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _alert = require('antd/lib/alert');

var _alert2 = _interopRequireDefault(_alert);

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

require('antd/lib/tabs/style/css');

require('antd/lib/alert/style/css');

require('antd/lib/modal/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LoginForm = require('./LoginForm');

var _LoginForm2 = _interopRequireDefault(_LoginForm);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var appid = 'dingoaodhkaxn4sviutdf9';
var redirectUrl = encodeURIComponent(window.location.protocol + '//sso.cathay-ins.com.cn/sso/dingding/callback');
var GOTO_URL = 'https://oapi.dingtalk.com/connect/oauth2/sns_authorize?appid=' + appid + '&response_type=code&scope=snsapi_login&state=STATE&redirect_uri=' + redirectUrl;

var LoginModal = function (_Component) {
  (0, _inherits3.default)(LoginModal, _Component);

  function LoginModal(_ref) {
    var callbackUrl = _ref.callbackUrl;
    (0, _classCallCheck3.default)(this, LoginModal);

    // 用在页面版单点登陆中
    var _this = (0, _possibleConstructorReturn3.default)(this, (LoginModal.__proto__ || (0, _getPrototypeOf2.default)(LoginModal)).call(this));

    _this.state = { visible: false };
    _this.callbackUrl = callbackUrl;
    _this.handleIframeMessage = _this.handleIframeMessage.bind(_this);

    if (typeof window.addEventListener !== 'undefined') {
      window.addEventListener('message', _this.handleIframeMessage, false);
    } else if (typeof window.attachEvent !== 'undefined') {
      window.attachEvent('onmessage', _this.handleIframeMessage);
    }
    return _this;
  }

  (0, _createClass3.default)(LoginModal, [{
    key: 'show',
    value: function show(lastFetch) {
      this.lastFetch = lastFetch;
      this.setState({
        visible: true
      });
    }
  }, {
    key: 'close',
    value: function close() {
      this.setState({
        visible: false
      });
    }
  }, {
    key: 'receiveTmpAuthCodeIframe',
    value: function receiveTmpAuthCodeIframe(url) {
      var iframe = document.createElement('iframe');
      iframe.src = url;
      iframe.frameBorder = '0';
      iframe.allowTransparency = 'true';
      iframe.scrolling = 'no';

      document.body.appendChild(iframe);
      return iframe;
    }
  }, {
    key: 'doAuthByFetch',
    value: function doAuthByFetch(type, data) {
      var lastFetch = this.lastFetch;
      if (!lastFetch) return;

      var url = lastFetch.url;
      var options = lastFetch.options;
      var headers = options.headers;

      switch (type) {
        case 'ddScan':
          // 兼容方案 start，去掉之前请确定所有java sdk等升级到指定版本
          headers['CATHAY_AUTH_TYPE'] = 'ddScan';
          headers['CATHAY_AUTH_DD_TMP_CODE'] = data;
          // 兼容方案 end

          headers['CATHAY-AUTH-TYPE'] = 'ddScan';
          headers['CATHAY-AUTH-DD-TMP-CODE'] = data;
          break;
        case 'password':
          // 兼容方案 start，去掉之前请确定所有java sdk等升级到指定版本
          headers['CATHAY_AUTH_TYPE'] = 'password';
          headers['CATHAY_AUTH_USERNAME'] = encodeURIComponent(data.username);
          headers['CATHAY_AUTH_PASSWORD'] = data.password;
          // 兼容方案 end

          headers['CATHAY-AUTH-TYPE'] = 'password';
          headers['CATHAY-AUTH-USERNAME'] = encodeURIComponent(data.username);
          headers['CATHAY-AUTH-PASSWORD'] = data.password;
          break;
        default:
          break;
      }

      this.doVerify(url, options, type);
    }
  }, {
    key: 'fetchCanBeRecover',
    value: function fetchCanBeRecover() {
      var lastFetch = this.lastFetch;

      var minite10 = 10 * 60 * 1000;

      // 如果距离上个请求的时间在10min以上，那么判断为页面初始化后的单次数据请求，直接恢复数据
      if (lastFetch.intervalTime > minite10) return true;

      // 累计fetch请求数 < 10 认为是首次加载页面，暂无想到更严谨的判断方法
      // @TODO
      return lastFetch.count >= 10;
    }
  }, {
    key: 'doVerify',
    value: function doVerify(url, options, type) {
      var _this2 = this;

      (0, _isomorphicFetch2.default)(url, options).then(function (res) {
        if (res.status === 401 || res.status === 400) {
          res.json().then(function (json) {
            var message = json.message || '账号或密码错误，请重试';

            var modal = _modal2.default.error({
              title: '登陆失败及提醒',
              width: 600,
              content: _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'p',
                  { style: { margin: '20px 0' } },
                  message
                ),
                _react2.default.createElement(_alert2.default, {
                  message: '\u539F\u56E0\u63D0\u9192: \u4E0D\u662F\u8001\u6838\u5FC3\u5BC6\u7801\uFF01',
                  description: _react2.default.createElement(
                    'p',
                    null,
                    '\u65B0\u6838\u5FC3\u7CFB\u7EDF\u7684\u5BC6\u7801\u4E0E\u8001\u6838\u5FC3\u7CFB\u7EDF\u5BC6\u7801\u4E0D\u4E00\u6837\uFF0C\u5206\u4E24\u79CD\u60C5\u51B5',
                    _react2.default.createElement(
                      'ul',
                      null,
                      _react2.default.createElement(
                        'li',
                        null,
                        '1. \u5BF9\u4E8E\u65B0\u5458\u5DE5\uFF1A\u5BC6\u7801\u4F1A\u901A\u8FC7\u77ED\u4FE1\u6216\u90AE\u7BB1\u5728\u5165\u804C\u5F53\u5929\u53D1\u9001\u7ED9\u5458\u5DE5'
                      ),
                      _react2.default.createElement(
                        'li',
                        null,
                        '2. \u5BF9\u4E8E\u8001\u5458\u5DE5\uFF1A\u5BC6\u7801\u4E3A2017\u5E74\u6700\u540E\u4E00\u5929\u8001\u6838\u5FC3\u7684\u5BC6\u7801'
                      )
                    ),
                    '\u66F4\u8BE6\u7EC6\u7684\u8BF4\u660E\uFF0C\u53EF\u4EE5\u53C2\u89C1\uFF1A',
                    _react2.default.createElement(
                      'a',
                      {
                        href: 'http://bbs.cathay-ins.com.cn/topic/5a532afd96c542bf3f18bc99',
                        target: '_blank'
                      },
                      '\u5173\u4E8E\u56FD\u6CF0\u5404\u7CFB\u7EDF\u7684\u8D26\u53F7\u3001\u5BC6\u7801\u8BF4\u660E'
                    ),
                    _react2.default.createElement('br', null),
                    _react2.default.createElement('br', null),
                    _react2.default.createElement(
                      'strong',
                      null,
                      '\u5982\u679C\u786E\u5B9E\u5FD8\u8BB0\u5BC6\u7801\uFF0C\u53EF\u4EE5\u901A\u8FC7`\u5BC6\u7801\u627E\u56DE`\u529F\u80FD\u91CD\u7F6E\u5BC6\u7801'
                    ),
                    _react2.default.createElement('img', {
                      alt: '',
                      width: '320',
                      src: 'http://cathay-cms-prod.oss-cn-hzfinance-internal.aliyuncs.com/prod/posts/ceb9803b0986e057e8abd891d358aeae.png'
                    })
                  ),
                  type: 'warning',
                  showIcon: true
                })
              )
            });

            setTimeout(function () {
              modal.destroy();
            }, 3000);
          });
        } else if (res.status === 200) {
          res.json().then(function (json) {
            return new _promise2.default(function (resolve, reject) {
              window.hufu.risk({
                fast: true,
                uId: json.data.uid,
                token: json.data.caToken,
                callback: resolve
              });
            });
          }).then(function () {
            _this2.close();

            // 用在页面版单点登陆中
            if (_this2.callbackUrl) {
              _modal2.default.success({
                title: '登陆成功',
                content: '登陆成功，页面会即将跳转'
              });

              setTimeout(function () {
                window.location.href = _this2.callbackUrl;
              }, 500);

              // 用在Modal版单点登陆中
            } else if (_this2.fetchCanBeRecover()) {
              var modal = _modal2.default.success({
                title: '登陆成功',
                content: '重新登陆成功，请重新完成个之前的操作'
              });
              setTimeout(function () {
                modal.destroy();
              }, 500);
              // 用在Modal版单点登陆中
            } else {
              _modal2.default.success({
                title: '登陆成功',
                content: '登陆成功，页面即将刷新'
              });

              setTimeout(function () {
                window.location.reload();
              }, 500);
            }
          });
        } else {
          return _promise2.default.reject(new Error('uncaught error'));
        }
      }).catch(function (err) {
        if (err) {
          var modal = _modal2.default.error({
            title: '登陆失败',
            content: '登陆异常，请重试，本窗口3s消失'
          });
          setTimeout(function () {
            modal.destroy();
          }, 3000);
        }
      });
    }
  }, {
    key: 'handleIframeMessage',
    value: function handleIframeMessage(event) {
      // 参考: https://open-doc.dingtalk.com/docs/doc.htm?treeId=168&articleId=104882&docType=1
      if (event.origin === 'https://login.dingtalk.com') {
        // 拿到loginTmpCode后就可以在这里构造跳转链接进行跳转了
        var loginTmpCode = event.data;
        this.iframe = this.receiveTmpAuthCodeIframe(GOTO_URL + '&loginTmpCode=' + loginTmpCode);
      } else if (typeof event.data === 'string') {
        var query = _queryString2.default.parse(event.data);
        if (query.code) this.doAuthByFetch('ddScan', query.code);
      }
    }
  }, {
    key: 'renderScanCode',
    value: function renderScanCode() {
      window.DDLogin({
        id: 'scanCode',
        goto: encodeURIComponent(GOTO_URL),
        width: '300px',
        height: '300px'
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var TabPane = _tabs2.default.TabPane;

      return _react2.default.createElement(
        _modal2.default,
        {
          title: '\u56FD\u6CF0\u7EDF\u4E00\u767B\u9646',
          visible: this.state.visible,
          onCancel: function onCancel() {
            _this3.close();
          },
          footer: ''
        },
        _react2.default.createElement(
          _tabs2.default,
          { type: 'card' },
          _react2.default.createElement(
            TabPane,
            { tab: '\u626B\u7801\u767B\u5F55', key: '1' },
            _react2.default.createElement('div', {
              id: 'scanCode',
              style: {
                width: 300,
                height: 300,
                marginBottom: 30,
                marginLeft: 80
              }
            }),
            _react2.default.createElement(
              'div',
              { className: 'sso-tips' },
              '\u56FD\u6CF0\u5458\u5DE5\u9ED8\u8BA4\u7ED1\u5B9A\u4E86\u9489\u9489\u626B\u7801\uFF0C\u5176\u4ED6\u8D26\u53F7\u9700\u8981\u767B\u9646\u540E\u81EA\u5DF1\u7ED1\u5B9A:',
              ' ',
              _react2.default.createElement(
                'a',
                { href: '//home.cathay-ins.com.cn/account/bind-dd' },
                '\u7ED1\u5B9A\u9489\u9489'
              )
            )
          ),
          _react2.default.createElement(
            TabPane,
            { tab: '\u8F93\u5165\u767B\u5F55', key: '2' },
            _react2.default.createElement(_LoginForm2.default, {
              doLogin: function doLogin(data) {
                _this3.doAuthByFetch('password', data);
              }
            }),
            _react2.default.createElement(
              'div',
              { className: 'sso-tips' },
              '\u5FD8\u8BB0\u5BC6\u7801\uFF1F',
              _react2.default.createElement(
                'a',
                { href: '//home.cathay-ins.com.cn/nologin/password/recover' },
                '\u627E\u56DE\u5BC6\u7801'
              ),
              '\xA0\xA0\xA0 or \xA0\xA0\xA0 \u8D26\u53F7\u88AB\u9501\uFF1F',
              _react2.default.createElement(
                'a',
                { href: '//home.cathay-ins.com.cn/nologin/password/unlock' },
                '\u8D26\u53F7\u89E3\u9501'
              )
            )
          )
        )
      );
    }
  }]);
  return LoginModal;
}(_react.Component);

exports.default = LoginModal;