'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.serializeQuery = undefined;

exports.default = function (rawUrl, options) {
  var _formatOptions = (0, _formatOptions3.default)(rawUrl, options),
      url = _formatOptions.url,
      ops = _formatOptions.ops;

  return (0, _isomorphicFetch2.default)(url, ops).then(function (response) {
    return response.json();
  }).then(function (result) {
    if (!result.success && result.message) window.alert(result.message);
    return result;
  }).catch(function (error) {
    var _error$statusText = error.statusText,
        statusText = _error$statusText === undefined ? '' : _error$statusText,
        _error$status = error.status,
        status = _error$status === undefined ? '' : _error$status;

    if (statusText) {
      window.alert('\u7F51\u7EDC\u8FDE\u63A5\u9519\u8BEF\uFF0C\u9519\u8BEF\u4FE1\u606F\uFF1A' + statusText);
    }

    if (status === 399) {
      window.location.href = error.headers.get('location');
    }
    window.alert('网络连接错误，请重试。');
  });
};

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _formatOptions2 = require('./utils/formatOptions.js');

var _formatOptions3 = _interopRequireDefault(_formatOptions2);

var _serializeQuery = require('./utils/serializeQuery.js');

var _serializeQuery2 = _interopRequireDefault(_serializeQuery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var serializeQuery = exports.serializeQuery = _serializeQuery2.default;