export default function (url, options = {}) {
  let { method = 'GET', body = {}, headers = {}, ...otherOps } = options
  // 处理参数
  method = method.toUpperCase()
  if ((method === 'POST' || method === 'PUT') && !headers['Content-Type']) {
    body = JSON.stringify(body)
    headers['Content-Type'] = 'application/json'
  }

  const ops = {
    method,
    credentials: 'include',
    headers,
    ...otherOps
  }
  if (method !== 'GET') ops.body = body
  return {
    url,
    ops
  }
}

//  强哥/始信 之前的代码
// function (options = {}) {
//     // TODO default method GET
//   let defaultOptions = {
//     method: 'POST',
//     credentials: 'include',
//     headers: {
//       'Content-Type': 'application/json'
//     }
//   }

//     // stringify 处理以及 isJava 处理
//   if (options.body) {
//     let body = options.body
//     if (typeof body !== 'string') {
//       body = JSON.stringify(body)
//     }

//         // 以值对方式提交数据
//         // TODO 此为非标准方式，WEBX可能需要，但在SpringMVC及SOFA_LITE下无必要存在
//     if (options.jsonPrefixBody) {
//       defaultOptions.headers['Content-Type'] = 'application/x-www-form-urlencoded'
//       body = 'json=' + body
//     }
//     options.body = body
//   }

//     // merge
//   let result = Object.assign({}, defaultOptions, options)

//   return result
// }
